package cn.ibizlab.humanresource.core.humanresource.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import cn.ibizlab.humanresource.util.domain.EntityBase;
import cn.ibizlab.humanresource.util.annotation.DEField;
import cn.ibizlab.humanresource.util.enums.DEPredefinedFieldType;
import cn.ibizlab.humanresource.util.enums.DEFieldDefaultValueType;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;
import cn.ibizlab.humanresource.util.annotation.Audit;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import cn.ibizlab.humanresource.util.domain.EntityMP;

/**
 * 实体[教育信息]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "T_HREDUCATION",resultMap = "HREducationResultMap")
public class HREducation extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 教育信息标识
     */
    @DEField(isKeyField=true)
    @TableId(value= "hreducationid",type=IdType.ASSIGN_UUID)
    @JSONField(name = "hreducationid")
    @JsonProperty("hreducationid")
    private String hreducationid;
    /**
     * 教育信息名称
     */
    @TableField(value = "hreducationname")
    @JSONField(name = "hreducationname")
    @JsonProperty("hreducationname")
    private String hreducationname;
    /**
     * 建立时间
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * 建立人
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * 更新人
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * 更新时间
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * 员工标识
     */
    @TableField(value = "hremployeeid")
    @JSONField(name = "hremployeeid")
    @JsonProperty("hremployeeid")
    private String hremployeeid;
    /**
     * 员工姓名
     */
    @TableField(exist = false)
    @JSONField(name = "hremployeename")
    @JsonProperty("hremployeename")
    private String hremployeename;
    /**
     * 学历
     */
    @TableField(value = "degree")
    @JSONField(name = "degree")
    @JsonProperty("degree")
    private String degree;
    /**
     * 入学时间
     */
    @TableField(value = "begintime")
    @JsonFormat(pattern="yyyy-MM-dd", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "begintime" , format="yyyy-MM-dd")
    @JsonProperty("begintime")
    private Timestamp begintime;
    /**
     * 毕业时间
     */
    @TableField(value = "endtime")
    @JsonFormat(pattern="yyyy-MM-dd", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "endtime" , format="yyyy-MM-dd")
    @JsonProperty("endtime")
    private Timestamp endtime;
    /**
     * 毕业院校
     */
    @TableField(value = "school")
    @JSONField(name = "school")
    @JsonProperty("school")
    private String school;
    /**
     * 一级学科
     */
    @TableField(value = "subject")
    @JSONField(name = "subject")
    @JsonProperty("subject")
    private String subject;
    /**
     * 专业
     */
    @TableField(value = "major")
    @JSONField(name = "major")
    @JsonProperty("major")
    private String major;
    /**
     * 学习形式
     */
    @TableField(value = "learnmodality")
    @JSONField(name = "learnmodality")
    @JsonProperty("learnmodality")
    private String learnmodality;
    /**
     * 学校性质
     */
    @TableField(value = "schooltype")
    @JSONField(name = "schooltype")
    @JsonProperty("schooltype")
    private String schooltype;
    /**
     * 是否最高学历
     */
    @TableField(value = "highdegreeflag")
    @JSONField(name = "highdegreeflag")
    @JsonProperty("highdegreeflag")
    private Integer highdegreeflag;
    /**
     * 是否第一学历
     */
    @TableField(value = "firstdegreeflag")
    @JSONField(name = "firstdegreeflag")
    @JsonProperty("firstdegreeflag")
    private Integer firstdegreeflag;
    /**
     * 其他附件
     */
    @TableField(value = "attachment")
    @JSONField(name = "attachment")
    @JsonProperty("attachment")
    private String attachment;
    /**
     * 毕业证
     */
    @TableField(value = "attachment1")
    @JSONField(name = "attachment1")
    @JsonProperty("attachment1")
    private String attachment1;
    /**
     * 学位证
     */
    @TableField(value = "attachment2")
    @JSONField(name = "attachment2")
    @JsonProperty("attachment2")
    private String attachment2;
    /**
     * 学历验证
     */
    @TableField(value = "attachment3")
    @JSONField(name = "attachment3")
    @JsonProperty("attachment3")
    private String attachment3;

    /**
     * 员工
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.humanresource.core.humanresource.domain.HREmployee hremployee;



    /**
     * 设置 [教育信息名称]
     */
    public void setHreducationname(String hreducationname){
        this.hreducationname = hreducationname ;
        this.modify("hreducationname",hreducationname);
    }

    /**
     * 设置 [员工标识]
     */
    public void setHremployeeid(String hremployeeid){
        this.hremployeeid = hremployeeid ;
        this.modify("hremployeeid",hremployeeid);
    }

    /**
     * 设置 [学历]
     */
    public void setDegree(String degree){
        this.degree = degree ;
        this.modify("degree",degree);
    }

    /**
     * 设置 [入学时间]
     */
    public void setBegintime(Timestamp begintime){
        this.begintime = begintime ;
        this.modify("begintime",begintime);
    }

    /**
     * 格式化日期 [入学时间]
     */
    public String formatBegintime(){
        if (this.begintime == null) {
            return null;
        }
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        return sdf.format(begintime);
    }
    /**
     * 设置 [毕业时间]
     */
    public void setEndtime(Timestamp endtime){
        this.endtime = endtime ;
        this.modify("endtime",endtime);
    }

    /**
     * 格式化日期 [毕业时间]
     */
    public String formatEndtime(){
        if (this.endtime == null) {
            return null;
        }
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        return sdf.format(endtime);
    }
    /**
     * 设置 [毕业院校]
     */
    public void setSchool(String school){
        this.school = school ;
        this.modify("school",school);
    }

    /**
     * 设置 [一级学科]
     */
    public void setSubject(String subject){
        this.subject = subject ;
        this.modify("subject",subject);
    }

    /**
     * 设置 [专业]
     */
    public void setMajor(String major){
        this.major = major ;
        this.modify("major",major);
    }

    /**
     * 设置 [学习形式]
     */
    public void setLearnmodality(String learnmodality){
        this.learnmodality = learnmodality ;
        this.modify("learnmodality",learnmodality);
    }

    /**
     * 设置 [学校性质]
     */
    public void setSchooltype(String schooltype){
        this.schooltype = schooltype ;
        this.modify("schooltype",schooltype);
    }

    /**
     * 设置 [是否最高学历]
     */
    public void setHighdegreeflag(Integer highdegreeflag){
        this.highdegreeflag = highdegreeflag ;
        this.modify("highdegreeflag",highdegreeflag);
    }

    /**
     * 设置 [是否第一学历]
     */
    public void setFirstdegreeflag(Integer firstdegreeflag){
        this.firstdegreeflag = firstdegreeflag ;
        this.modify("firstdegreeflag",firstdegreeflag);
    }

    /**
     * 设置 [其他附件]
     */
    public void setAttachment(String attachment){
        this.attachment = attachment ;
        this.modify("attachment",attachment);
    }

    /**
     * 设置 [毕业证]
     */
    public void setAttachment1(String attachment1){
        this.attachment1 = attachment1 ;
        this.modify("attachment1",attachment1);
    }

    /**
     * 设置 [学位证]
     */
    public void setAttachment2(String attachment2){
        this.attachment2 = attachment2 ;
        this.modify("attachment2",attachment2);
    }

    /**
     * 设置 [学历验证]
     */
    public void setAttachment3(String attachment3){
        this.attachment3 = attachment3 ;
        this.modify("attachment3",attachment3);
    }


}


