package cn.ibizlab.humanresource.core.pcm.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.HashMap;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.humanresource.core.pcm.domain.HRTransferApply;
import cn.ibizlab.humanresource.core.pcm.filter.HRTransferApplySearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.alibaba.fastjson.JSONObject;

public interface HRTransferApplyMapper extends BaseMapper<HRTransferApply>{

    Page<HRTransferApply> searchDefault(IPage page, @Param("srf") HRTransferApplySearchContext context, @Param("ew") Wrapper<HRTransferApply> wrapper) ;
    @Override
    HRTransferApply selectById(Serializable id);
    @Override
    int insert(HRTransferApply entity);
    @Override
    int updateById(@Param(Constants.ENTITY) HRTransferApply entity);
    @Override
    int update(@Param(Constants.ENTITY) HRTransferApply entity, @Param("ew") Wrapper<HRTransferApply> updateWrapper);
    @Override
    int deleteById(Serializable id);
     /**
      * 自定义查询SQL
      * @param sql
      * @return
      */
     @Select("${sql}")
     List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);

    List<HRTransferApply> selectByHremployeeid(@Param("employeeid") Serializable employeeid) ;

    List<HRTransferApply> selectByHrorganizationid2(@Param("organizationid") Serializable organizationid) ;

    List<HRTransferApply> selectByHrpostid2(@Param("hrpostid") Serializable hrpostid) ;

}
